#59
# Helmerttransformation Version 1.02 -- 25.9.2023
# copyright 2023, Norbert Fuhrmann, Kerpen
# www.grenzuntersuchung.de

from tkinter import *
import math, decimal, tkinter, os, time
from tkinter import filedialog, messagebox

class Helmerttransformation():

    def toja(self):    # Schalter zwischen orthogonal=o und polar=p
        self.bjao.configure(text="Ja")
        self.bjao.configure(bg="Lightgreen")
        self.hel='o'
        self.bjap.configure(text="Nein")
        self.bjap.configure(bg="pink")

    def tpja(self):
        self.bjao.configure(text="Nein")
        self.bjao.configure(bg="pink")
        self.hel='p'
        self.bjap.configure(text="Ja")
        self.bjap.configure(bg="Lightgreen")
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def __init__(self):
        self.druck=0  # Kann nicht gedruckt werden
        self.marke=0  # <KeyPress> noch nicht gedrückt s. transformation()
        self.tprojekt=''
        self.fenster=Tk()
        path_file1=os.path.dirname(os.path.realpath(__file__))+ "/Helmert2.png"
        photo1=PhotoImage(file=path_file1)
        self.fenster.iconphoto(False, photo1)
        self.fenster.title("1.02")

        self.frame=Frame(self.fenster, width=150)
        self.frame.pack()

        self.textueber=Label(self.frame, text="",
            font=('Arial',12))
        self.textueber.pack(side=RIGHT, pady=10)
        self.tueber=Label(self.frame, text="Helmerttransformation", fg='blue', \
            font=('Arial',14))
        self.tueber.pack()
#--------------------------------------------------------------

        #Bildung der Entreefenster

        self.frame1=Frame(self.fenster, relief=FLAT, pady=3,bd=2)
        self.frame1.pack()

        self.hel='o'
        self.text10=Label(self.frame1, text='eines orthogonalen Systems',\
            width=30, font=('Arial',8))
        self.text10.grid(column=0, columnspan=3, row=0, ipady=3)
        self.text10.pack

        self.bjao=Button(self.frame1, width=4, text="Ja", bg='Lightgreen', bd=2,
                command=self.toja)
        self.bjao.grid(column=4, row=0)
        self.bjao.pack
        self.text11=Label(self.frame1, text='            einer Polaraufnahme',\
            width=30, font=('Arial',8))
        self.text11.grid(column=0, columnspan=3, row=1, ipady=3)
        self.text11.pack

        self.bjap=Button(self.frame1, width=4,text="Nein", bg="pink", bd=2,
            command=self.tpja)
        self.bjap.grid(column=4, row=1, padx=0, pady=0)
        self.bjap.pack
#--------------------------------------------------------------

        # Angaben zur manuellen Eingabe

        self.frame2=Frame(self.fenster, relief=RIDGE,bd=5)
        self.frame2.pack(anchor='nw')

        self.text2a=Label(self.frame2, text='Bei manueller Eingabe:',\
            width=30, font=('Arial',10))
        self.text2a.grid(column=0, columnspan=3, row=0)
        self.text2a.pack

        self.text2b=Label(self.frame2, text='Anzahl der Passpunkte (max. 10)\n(Defaultwert=3)',\
            width=30, font=('Arial',8))
        self.text2b.grid(column=0, columnspan=3, row=1, pady=3)
        self.text2b.pack
        self.nalt=Entry(self.frame2, width=2)
        self.nalt.grid(column=3, row=1, pady=0)
        self.nalt.delete(0,END)
        self.nalt.insert(0, "3")
        self.nalt.pack

        self.text2c=Label(self.frame2, text='Anzahl der Neupunkte (max. 10)\n(Defaultwert=1)',\
            width=30, font=('Arial',8))
        self.text2c.grid(column=0, columnspan=3, row=2, ipady=3)
        self.text2c.pack
        self.nneu=Entry(self.frame2, width=2)
        self.nneu.grid(column=3, row=2, pady=0)
        self.nneu.insert(0, "1")

        self.text2d=Label(self.frame2, text='Additionswert für Zielsystem Y (UTM)',\
            width=30, font=('Arial',8))
        self.text2d.grid(column=0, columnspan=3, row=3, ipady=3)
        self.text2d.pack
        self.addy=Entry(self.frame2, width=9)
        self.addy.grid(column=3, row=3, pady=0)
        self.addy.insert(0, "0")

        self.text2e=Label(self.frame2, text='Additionswert für Zielsystem X (UTM)',\
            width=30, font=('Arial',8))
        self.text2e.grid(column=0, columnspan=3, row=4, ipady=3)
        self.text2e.pack
        self.addx=Entry(self.frame2, width=9)
        self.addx.grid(column=3, row=4, pady=0)
        self.addx.insert(0, "0")
#--------------------------------------------------------------

        # Vorauswahl für manuelle Eingabe oder Dateiauswahl
        self.frame3=Frame(self.fenster, relief=FLAT)
        self.frame3.pack(anchor=N,fill=X)
        try:
            self.text3a=Label(self.frame3, text='             Eingabe:    ')
            self.text3a.pack(side=LEFT)

            self.eingabe=IntVar()

            reingabe1=Radiobutton(self.frame3, text="manuell   ", \
                variable=self.eingabe, value=1)
            reingabe1.pack(side=LEFT)
            reingabe1.select()
            reingabe2=Radiobutton(self.frame3, text="aus Datei", \
                variable=self.eingabe, value=2)
            reingabe2.pack(side=LEFT)
            self.being=Button(self.frame3, width=2, text="\u2714", fg='blue', bd=6,
                command=self.dateieingabe)
            self.being.pack(side=RIGHT)
        except:
            tkinter.messagebox.showinfo("          Achtung", "Bitte auswählen:\nmanuelle \
Eingabe oder Eingabe aus Datei!.")

        self.fenster.mainloop()
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def warnzeichen(self):
        self.textueber["text"]="\u26A0"
        self.textueber["fg"]='red'

    def taste(self, event):
        if self.marke==1:
            self.warnzeichen()
        self.marke=0
        self.brechnen["text"]='Erneut\nRechnen'

    def taste2(self):
        self.warnzeichen() 
        self.brechnen["text"]='Erneut\nRechnen'

    def loeschen(self):
        self.fenster.destroy()
        self.__init__()

    def beenden(self):
        self.fenster.destroy()

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  

    def dateieingabe(self):
        try:
          if self.eingabe.get()==1:    # manuelle Eingabe
              if int(self.nalt.get()) > 10 or int(self.nalt.get()) < 2 or \
                       int(self.nneu.get()) > 10 or int(self.nneu.get()) < 0:
                  tkinter.messagebox.showerror("Fehler", "Fehlerhafte Anzahl der Punkte")
                  return

              self.faddy=float(self.addy.get()) ; self.faddx=float(self.addx.get())
              self.nalt=int(self.nalt.get())
              self.nneu=int(self.nneu.get())
    
          elif self.eingabe.get()==2:     # Eingabe aus Datei
              self.faddy=0.; self.faddx=0.

              # Initialisieren des Arrays für die Koordinaten aus Datei

              self.koord_list_alt_ortho=[]
              self.koord_list_neu_ortho=[]
              self.koord_list_alt_polar=[]
              self.koord_list_neu_polar=[]

              try:# Öffne den Dateidialog
                  file_path=filedialog.askopenfilename(parent=self.fenster, initialdir="/",
                      title="Datei auswählen", filetypes=(("Textdokumente", "*.txt"),("Alle Dateien", "*.*")))

                  # Öffnen der Textdatei und Erzeugen von Textzeilen
                  with open(file_path, 'r') as file: content=file.read()

                  # Trennen des Inhalts in einzelne Zeilen
                  lines=content.splitlines()

                  self.nalt=0
                  self.nneu=0
                  self.file_path_red = file_path.replace('.txt','')
              except:
                  tkinter.messagebox.showerror("Fehler", "Datei nicht einlesbar!")
                  self.textueber["text"]=""
                  return
              for line in lines:
                  if line.strip() == 0: continue
                  line=line.replace(',', '.')
                  self.substring=line[0:2]

                  # Trennen des Eingabe-Textdatei in einzelne Zeilen für orthogonale Elemente
                                 
                  if self.substring=='01':         
                     self.tprojekt=line[3:]

                  if self.hel=='o':
                      if self.substring=='10':
                          self.nalt +=1
                          self.koord_list_alt_ortho.append(line)
                      if self.substring=='20':
                          self.nneu +=1
                          self.koord_list_neu_ortho.append(line)

                  # Trennen der Textdatei in einzelne Zeilen für polare Elemente

                  if self.hel=='p':
                      if self.substring=='30':
                          self.nalt +=1
                          self.koord_list_alt_polar.append(line)
                      if self.substring=='40':
                          self.nneu +=1
                          self.koord_list_neu_polar.append(line)
        except:
            tkinter.messagebox.showerror("Fehler", "Fehlerhafte Datei oder Eingabe")
            return
        command=self.anzeige_eingabe()
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def anzeige_eingabe(self):

        #Entreefenster löschen

        self.frame.destroy()
        self.frame1.destroy()
        self.frame2.destroy()
        self.frame3.destroy()
#--------------------------------------------------------------

        #Bildung der Hauptframes

        self.frame20=Frame(self.fenster, relief=RIDGE, bd=6, padx=2, pady=2)
        self.frame20.pack(side=LEFT)
        self.frame30=Frame(self.fenster, relief=FLAT, bd=2)
        self.frame30.pack(side=LEFT,fill="both", expand=True)
        self.frame40=Frame(self.fenster, relief=RIDGE, bd=6, padx=2, pady=2)
        self.frame40.pack(side=LEFT)
#--------------------------------------------------------------

        #Inhalt frame20     Passpunkttabellen

        self.frame21=Frame(self.frame20, relief=FLAT, bd=2, padx=2, pady=2)
        self.frame21.pack(anchor=N)
        self.text21=Label(self.frame21, text='Elemente bzw. Koordinaten der \
Passpunkte', font=('Arial',12))
        self.text21.grid(column=0, columnspan=10, row=0)
        self.text21.pack

        self.frame22=Frame(self.frame20, relief=FLAT, bd=2, padx=2, pady=2)
        self.frame22.pack(anchor=N)
        self.text22a=Label(self.frame22, text='vom System A                         \
zum System B (Ziel)           ', font=('Arial',10))
        self.text22a.grid(column=0, columnspan=10, row=0)
        self.text22a.pack

        if self.hel=='o':
            self.text22b=Label(self.frame22, text='Nr      PKZ                      \
y\u1D62, x\u1D62                 Aktiv               Y\u1D62, X\u1D62                \
   vy\u1D62      vx\u1D62     Klaffe            ', font=('Arial',10))
            self.text22b.grid(column=0, columnspan=10, row=1)
            self.text22b.pack
        else:
            self.text22c=Label(self.frame22, text='Nr     PKZ      Richtung, Zenitdist., \
Strecke Aktiv              Y\u1D62, X\u1D62                   vy\u1D62      vx\u1D62     Klaffe            ' , font=('Arial',10))
            self.text22c.grid(column=0, columnspan=10, row=1)
            self.text22c.pack
#--------------------------------------------------------------

        #Mittelteil frame30   Parameterwahl und Ergebnisse

        self.frame31=Frame(self.frame30)
        self.frame31.pack()
        self.textueber=Label(self.frame31, text="", font=('Arial',12))
        self.textueber.pack(side=RIGHT, pady=5)
        self.text31=Label(self.frame31, text="\nHelmerttransformation", fg='blue',
            font=('Arial',14))
        self.text31.pack()

        self.c=Canvas(self.frame30, width='8.3c', height='0.3c', relief=FLAT)
        self.rec=self.c.create_rectangle('0.1c','0c','8.3c','0.2c', outline='',
            fill='green')
        self.c.pack()

        #Reduktion und Verzerrung

        self.frame32=Frame(self.frame30, relief=RIDGE,width=300, bd=2)
        self.frame32.pack()

        self.frame321=Frame(self.frame32, relief=FLAT)
        self.frame321.pack(anchor=N,fill=X)
        self.verz=StringVar()
        self.verz.set("0")
        self.rverzn=Radiobutton (self.frame321, text="nein   ", value="0",
            variable=self.verz, command=self.taste2)
        self.rverzn.pack(side=RIGHT)
        self.rverzj=Radiobutton (self.frame321, text="ja", value="1",
            variable=self.verz, command=self.taste2)
        self.rverzj.select()
        self.rverzj.pack(side=RIGHT)
        self.text321=Label(self.frame321, text='Reduktion (Höhe) und Verzerrung (UTM) ')
        self.text321.pack(side=RIGHT)

        self.frame322=Frame(self.frame32, relief=FLAT)
        self.frame322.pack(anchor=E,fill=BOTH)
        self.text322a=Label(self.frame322, text='Höhe über NHN\n Default \u27F9 100 [m] ')
        self.text322a.pack(side=LEFT)
        self.hoeheNHN=Entry(self.frame322, width=6)
        self.hoeheNHN.pack(side=LEFT)
        self.hoeheNHN.insert(0, "100")

        self.text322b=Label(self.frame322, text='  Undulation \n  \u27F9 46.5 [m]')
        self.text322b.pack(side=LEFT)
        self.undulation=Entry(self.frame322, width=5)
        self.undulation.pack(side=LEFT)
        self.undulation.insert(0,"46.5")

        self.text322c=Label(self.frame322, text='  mittl. Ostwert \n  \u27F9 319.5 [km]')
        self.text322c.pack(side=LEFT)
        self.ostwert=Entry(self.frame322, width=5)
        self.ostwert.pack(side=LEFT)
        self.ostwert.insert(0,"319.5")

        # Maßstab

        self.frame33=Frame(self.frame30, relief=RIDGE, bd=2)
        self.frame33.pack()

        self.frame331=Frame(self.frame33, relief=FLAT)
        self.frame331.pack(anchor=N, fill=X)
        self.ntransm=StringVar()
        self.ntransm.set("0")
        self.rbn=Radiobutton (self.frame331, text="nein   ", value="0",
            variable=self.ntransm, command=self.taste2)
        self.rbn.pack(side=RIGHT)
        self.rbj=Radiobutton (self.frame331, text="ja", value="1",
            variable=self.ntransm, command=self.taste2) 
        self.rbj.select()
        self.rbj.pack(side=RIGHT)
        self.text331=Label(self.frame331, text=' Maßstab (m*A \u27f9 B) mit m=1 ')
        self.text331.pack(side=RIGHT)

        # Restklaffenverteilung

        self.frame332=Frame(self.frame33, relief=FLAT)
        self.frame332.pack(anchor=N, fill=X)
        self.ntransr=IntVar()
        self.ntransr.set(0)
        self.rb3=Radiobutton (self.frame332, text="1/s\u00B2    ", value=3,
            variable=self.ntransr, command=self.taste2)
        self.rb3.pack(side=RIGHT)
        self.rb2=Radiobutton (self.frame332, text="1/(s\u221As)", value=2,
            variable=self.ntransr, command=self.taste2) 
        self.rb2.select()
        self.rb2.pack(side=RIGHT)
        self.rbl=Radiobutton (self.frame332, text="1/s", value=1,
            variable=self.ntransr, command=self.taste2)
        self.rbl.select()
        self.rbl.pack(side=RIGHT)
        self.rb0=Radiobutton (self.frame332, text="keine", value=0,
            variable=self.ntransr, command=self.taste2) 
        self.rb0.select()
        self.rb0.pack(side=RIGHT)
        self.text332=Label(self.frame332, text='           Restklaffenverteilung ')
        self.text332.pack(side=RIGHT)

        self.c=Canvas(self.frame30, width='8.3c', height='0.3c', relief=FLAT)
        self.rec=self.c.create_rectangle('0.1c','0c','8.3c','0.2c', outline='', fill='blue')
        self.c.pack()

        # Ergebnisse der Transformation
        if self.hel == "o":
            self.text34=Label(self.frame30, text='Ergebnisse der Transformation')
        else:
            self.text34=Label(self.frame30,
                    text='Ergebnisse der Transformation\naus der Polaraufnahme')
        self.text34.pack()

        self.c=Canvas(self.frame30, width='8.3c', height='0.3c', relief=FLAT)
        self.rec=self.c.create_rectangle('0.1c','0c','8.3c','0.2c', outline='', fill='grey')
        self.c.pack()

        # Hauptbuttons

        self.frame35=Frame(self.frame30, relief=RIDGE,bd=0)
        self.frame35.pack()
        self.brechnen=Button(self.frame35, width=7, height=2, text='Rechnen', bd=6,
                command=self.transformation)
        self.brechnen.pack(side=LEFT)

        self.bausgabe=Button(self.frame35, width=10, height=2, text='Textausgabe', bd=6,
                command=self.printausgabe)
        self.bausgabe.pack(side=LEFT)

        self.bausgabe=Button(self.frame35, width=10, height=2, text='Punktegrafik', bd=6,
                command=self.punktegrafik)
        self.bausgabe.pack(side=LEFT)

        self.bloeschen=Button(self.frame35, width=7, height=2, text="Löschen",bd=6,
                command=self.loeschen)
        self.bloeschen.pack(side=LEFT)

        self.bende=Button(self.frame35, width=7, height=2,text="Ende", fg='red',bd=6,
                command=self.beenden)
        self.bende.pack(side=LEFT)
#--------------------------------------------------------------

        # Ausgabeframe rechts frame40    zu transformierende Punkte
        self.frame41=Frame(self.frame40, relief=FLAT, bd=2, padx=2, pady=2)
        self.frame41.pack(anchor=N)
        self.text41=Label(self.frame41, text='zu transformierende Punkte', font=('Arial',12))
        self.text41.grid(column=0, columnspan=8, row=0, pady=0)
        self.text41.pack

        self.frame42=Frame(self.frame40, relief=FLAT, bd=2, padx=2, pady=2)
        self.frame42.pack(anchor=N)
        self.text42a=Label(self.frame42, text='                              vom System A               zum System B (Ziel)                    ', font=('Arial',10))
        self.text42a.grid(column=0, columnspan=8, row=0)
        self.text42a.pack
        if self.hel=='o':
            self.text42b=Label(self.frame42,
                text='Nr.       PKZ                    y\u2C7C, x\u2C7C                                Y\u2C7C, X\u2C7C     \
\u0028uy\u2C7C\u0029, \u0028ux\u2C7C\u0029 (angepasst)', font=('Arial',10))
        else:
            self.text42b=Label(self.frame42,
                text='Nr.    PKZ      Richtung, Zenitdist., Strecke                 Y\u2C7C, X\u2C7C\
    \u0028uy\u2C7C\u0029, \u0028ux\u2C7C\u0029 (angepasst)', font=('Arial',10))    
        self.text42b.grid(column=0,columnspan=8, row=1)
        self.text42b.pack

        command=self.aufbau()
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def aufbau(self):       # Aufbau der Tabellen
      try:
        # Create a Frame with Scrollbar
        mframe=Frame(self.frame20,relief=RIDGE, bd=2)
        mframe.pack(side=LEFT, fill=BOTH, expand=1)

        mscrollbar=Scrollbar(mframe, orient=VERTICAL)
        mscrollbar.pack(side=RIGHT, fill=Y)

        # Create a Canvas
        mcanvas=Canvas(mframe, yscrollcommand=mscrollbar.set)
        mcanvas.pack(side=RIGHT, fill=BOTH, expand=1)

        # Configure the Scrollbar to the Canvas
        mscrollbar.config(command=mcanvas.yview)

        # Create another Frame inside the Canvas
        first_frame=Frame(mcanvas)

        #Initialisieren der Eingabedaten
        self.pkza, self.by, self.bx=[], [], []  # für Frame20
        self.aktivtext, self.aktiv, self.vy, self.vx, self.fvy, self.fvx, self.klaffe, self.baktiv=[], [], [], [], [], [], [], []
        self.pkzj, self.byj, self.bxj=[], [], [] # für Frame40

        if self.hel=='o':       #für o Frame20, 40
            self.ay, self.ax, self.ayj, self.axj=[], [], [], []
        if self.hel=='p':       #für p Frame20, 40
            self.arichtung, self.azenitdistanz, self.astrecke, self.arichtungj, self.azenitdistanzj, self.astreckej=[], [], [], [], [], []

        for i in range(self.nalt):
            self.pkza.append(''); self.by.append(''); self.bx.append('')
            self.aktivtext.append(''); self.aktiv.append(1)
            self.vy.append(''); self.vx.append(''); self.fvy.append('')
            self.fvx.append('') 
            self.klaffe.append(''); self.baktiv.append('')
            if self.hel=='o':
                self.ay.append(''); self.ax.append('')
            if self.hel=='p':
                self.arichtung.append('');  self.azenitdistanz.append('')
                self.astrecke.append('')

        # Add the second Frame to the canvas
        mcanvas.create_window((0,0), window=first_frame, anchor="nw")

        # Configure the Canvas to fit the first Frame
        mframe.update_idletasks()

        for i in range(self.nalt):
            icolumn=0
            self.Nr=Label(first_frame, text=i+1, font=('Arial',9))
            self.Nr.grid(column=icolumn, row=i+2, pady=0)

            self.pkza[i]=Entry(first_frame, width=11)
            self.pkza[i].grid(column=icolumn+1, row=i+2, padx=5)
            self.pkza[i].pack
            if self.hel=='o':
                self.ay[i]=Entry(first_frame, width=12)
                self.ay[i].grid(column=icolumn+2, row=i+2)
                self.ay[i].pack

                self.ax[i]=Entry(first_frame, width=11)
                self.ax[i].grid(column=icolumn+3, row=i+2)
                self.ax[i].pack

            if self.hel=='p':
                self.arichtung[i]=Entry(first_frame, width=8)
                self.arichtung[i]. grid(column=icolumn+2, row=i+2)
                self.arichtung[i].pack

                self.azenitdistanz[i]=Entry(first_frame, width=8)
                self.azenitdistanz[i].grid(column=icolumn+3, row=i+2)
                self.azenitdistanz[i].pack

                self.astrecke[i]=Entry(first_frame, width=8)
                self.astrecke[i].grid(column=icolumn+4, row=i+2)
                self.astrecke[i].pack
                icolumn +=1

            self.aktivtext[i]=Entry(first_frame,width=5, relief=FLAT, bg="#F0F0F0")
            self.aktivtext[i].grid(column=icolumn+4, row=i+2, padx=0, pady=0)
            self.aktivtext[i].pack
            self.aktivtext[i].insert(0,"   Ja")
            self.aktivtext[i].configure(state='disabled')
            self.aktivtext[i].configure(disabledforeground="green")

            self.by[i]=Entry(first_frame, width=12)
            self.by[i].grid(column=icolumn+5, row=i+2, pady=0)
            self.by[i].pack

            self.bx[i]=Entry(first_frame, width=11)
            self.bx[i].grid(column=icolumn+6, row=i+2, pady=0)
            self.bx[i].pack

            self.vy[i]=Entry(first_frame, width=6, bg='LightYellow')
            self.vy[i].grid(column=icolumn+7, row=i+2, pady=0)
            self.vy[i].pack

            self.vx[i]=Entry(first_frame, width=6, bg='LightYellow')
            self.vx[i].grid(column=icolumn+8, row=i+2, pady=0)
            self.vx[i].pack

            self.klaffe[i]=Entry(first_frame, width=6, bg='LightYellow')
            self.klaffe[i].grid(column=icolumn+9, row=i+2, pady=0)
            self.klaffe[i].pack

            self.baktiv[i]=tkinter.Button(first_frame, text="\u2714", width=2, bg='white', fg='blue',\
                bd=4,relief="raised", command=lambda index=i: [self.bposition(index) ]).grid(column=icolumn+10, row=i+2, pady=0)

        # Add the second Frame to the canvas
        mcanvas.create_window((0,0), window=first_frame, anchor="nw")

        # Configure the Canvas to fit the third Frame
        first_frame.update_idletasks()
        mcanvas.config(scrollregion=mcanvas.bbox("all"))

        #--------------------------------------------------------------
        # Bildung der Entry-Felder in frame40

        # Create a Frame with Scrollbar
        m2frame=Frame(self.frame40,relief=RIDGE, bd=2)
        m2frame.pack(side=LEFT, fill=BOTH, expand=1)

        m2scrollbar=Scrollbar(m2frame, orient=VERTICAL)
        m2scrollbar.pack(side=RIGHT, fill=Y)

        # Create a Canvas
        m2canvas=Canvas(m2frame, yscrollcommand=m2scrollbar.set)
        m2canvas.pack(side=RIGHT, fill=BOTH, expand=1)

        # Configure the Scrollbar to the Canvas
        m2scrollbar.config(command=m2canvas.yview)

        # Create another Frame inside the Canvas
        second_frame=Frame(m2canvas)

        # Initialisieren der Eingabedaten

        self.pkzj, self.byj, self.bxj, self.uyj, self.uxj=[], [], [], [], []
        if self.hel=='o':
            self.ayj, self.axj=[], []
        if self.hel=='p':
            self.arichtungj, self.azenitdistanzj, self.astreckej=[], [], []

        for j in range(self.nneu):
            self.pkzj.append(''); self.byj.append(''); self.bxj.append('')
            self.uyj.append(''); self.uxj.append('')
            if self.hel=='o':
                self.ayj.append(''); self.axj.append('')
            if self.hel=='p':
                self.arichtungj.append(''); self.azenitdistanzj.append('')
                self.astreckej.append('')

        # Add the second Frame to the canvas
        m2canvas.create_window((0,0), window=second_frame, anchor="nw")

        # Configure the Canvas to fit the third Frame
        second_frame.update_idletasks()
        m2canvas.config(scrollregion=m2canvas.bbox("all"))

        for j in range(self.nneu):
            icolumn=0
            k=self.nalt +1 + j
            self.Nr=Label(second_frame, text=k , font=('Arial',9))
            self.Nr.grid(column=0, row=j+2, pady=0)

            self.pkzj[j]=Entry(second_frame, width=11)
            self.pkzj[j].grid(column=icolumn+1, row=j+2, padx=5)
            self.pkzj[j].pack

            if self.hel=='o':
                self.ayj[j]=Entry(second_frame, width=12)
                self.ayj[j].grid(column=icolumn+2, row=j+2, pady=0)
                self.ayj[j].pack

                self.axj[j]=Entry(second_frame, width=11)
                self.axj[j].grid(column=icolumn+3, row=j+2, pady=0)
                self.axj[j].pack

            if self.hel=='p':
                self.arichtungj[j]=Entry(second_frame, width=8)
                self.arichtungj[j]. grid(column=icolumn+2, row=j+2)
                self.arichtungj[j].pack

                self.azenitdistanzj[j]=Entry(second_frame, width=8)
                self.azenitdistanzj[j].grid(column=icolumn+3, row=j+2)
                self.azenitdistanzj[j].pack

                self.astreckej[j]=Entry(second_frame, width=8)
                self.astreckej[j].grid(column=icolumn+4, row=j+2)
                self.astreckej[j].pack
                icolumn +=1

            self.byj[j]=Entry(second_frame, width=12, bg='LightYellow')
            self.byj[j].grid(column=icolumn+4, row=j+2, padx=5, pady=0)
            self.byj[j].pack

            self.bxj[j]=Entry(second_frame, width=11, bg='LightYellow')
            self.bxj[j].grid(column=icolumn+5, row=j+2, padx=0, pady=0)
            self.bxj[j].pack

            self.uyj[j]=Entry(second_frame, width=6, bg='LightYellow')
            self.uyj[j].grid(column=icolumn+6, row=j+2, padx=0, pady=0)
            self.uyj[j].pack

            self.uxj[j]=Entry(second_frame, width=6, bg='LightYellow')
            self.uxj[j].grid(column=icolumn+7, row=j+2, padx=0, pady=0)
            self.uxj[j].pack

        # Add the second Frame to the canvas
        m2canvas.create_window((0,0), window=second_frame, anchor="nw")

        # Configure the Canvas to fit the third Frame
        second_frame.update_idletasks()
        m2canvas.config(scrollregion=m2canvas.bbox("all"))

        # Add Eingaben aus Datei und deren Zeilen

        if self.eingabe.get()==2:
            if self.hel=='o':
                for i in range(self.nalt):
                    lines2=self.koord_list_alt_ortho[i].splitlines()
                    liste3=lines2[0]
                    liste4=liste3.split(";")

                    self.pkza[i].insert(0, liste4[1].lstrip().rjust(10))
                    # beidseitig Leerzeichen entfernen,linksseitig Leerzeichen auffüllen
                    self.ay[i].insert(0, liste4[2].lstrip())
                    self.ax[i].insert(0, liste4[3].lstrip())
                    self.by[i].insert(0, liste4[4].lstrip())
                    self.bx[i].insert(0, liste4[5].lstrip())

                for j in range(self.nneu):
                    lines2=self.koord_list_neu_ortho[j].splitlines()
                    liste3=lines2[0]
                    liste4=liste3.split(";")

                    self.pkzj[j].insert(0, liste4[1].lstrip().rjust(10))
                    self.ayj[j].insert(0, liste4[2].lstrip())
                    self.axj[j].insert(0, liste4[3].lstrip())

            if self.hel=='p':
                for i in range(self.nalt):
                    lines2=self.koord_list_alt_polar[i].splitlines()
                    liste3=lines2[0]
                    liste4=liste3.split(";")

                    self.pkza[i].insert(0, liste4[1].lstrip().rjust(10))
                    self.arichtung[i].insert(0, liste4[2].lstrip())
                    self.azenitdistanz[i].insert(0, liste4[3].lstrip())
                    self.astrecke[i].insert(0, liste4[4].lstrip())
                    self.by[i].insert(0, liste4[5].lstrip())
                    self.bx[i].insert(0, liste4[6].lstrip())

                for j in range(self.nneu):
                    lines2=self.koord_list_neu_polar[j].splitlines()
                    liste3=lines2[0]
                    liste4=liste3.split(";")

                    self.pkzj[j].insert(0, liste4[1].lstrip().rjust(10))
                    self.arichtungj[j].insert(0, liste4[2].lstrip())
                    self.azenitdistanzj[j].insert(0, liste4[3].lstrip())
                    self.astreckej[j].insert(0, liste4[4].lstrip())

      except:
            tkinter.messagebox.showerror("Fehler", "Fehlerhafte Eingabe, Dateistruktur\nFalsche \
Zeichen, unerlaubt leeres Feld … ?")
            self.textueber["text"]=""
            return
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def transformation(self):       # Verarbeitung der Daten
        try:
            if self.fenster.bind('<KeyPress>',self.taste):# or self.fenster.bind('<Radiobutton>',self.taste) :
                self.marke=1
            self.textueber["text"]=" \u2713"
            self.textueber["fg"]='mediumseagreen'
            self.brechnen["text"]='Rechnen'

            # Initialierung der float-Variablen

            if self.hel=='p': self.farichtung, self.fazenitdistanz, self.fastrecke, \
                self.farichtungj, self.fazenitdistanzj, self.fastreckej=[],[],[],[],[],[]
            self.fay, self.fax, self.fby, self.fbx, self.fbyger, self.fbxger, self.fvy, \
                      self.fvx, self.fklaffe=[],[],[],[],[],[],[],[],[]

            for q in range(self.nalt):
                if self.hel=='p': self.farichtung.append(0.); self.fazenitdistanz.append(0.); self.fastrecke.append(0.)
                self.fay.append(0.); self.fax.append(0.); self.fby.append(0.); self.fbx.append(0.)
                self.fbyger.append(0.); self.fbxger.append(0.)
                self.fvy.append(0.); self.fvx.append(0.); self.fklaffe.append(0.)

            if self.verz.get()=="1":          # Reduktion
                fr=6381.
                self.fhoeheNHN = float(self.hoeheNHN.get())
                self.fundulation = float(self.undulation.get())
                self.fostwert = float(self.ostwert.get())
                self.fkorrektur=0.9996 *(1 - (self.fhoeheNHN  + self.fundulation)* \
                    0.001/fr + (self.fostwert  - 500.)**2/(2.* fr * fr))
                self.korrektur=self.fkorrektur
            else:
                self.korrektur=1.

            self.nnaktiv=0      # Anzahl der aktiven Passpunkte

            # Erzeugung der float-Variablen Frame20

            for i in range(self.nalt):
                if self.aktiv[i]==1:
                    self.nnaktiv +=1
                if self.hel=='o':
                        self.fay[i]=float(self.ay[i].get()) * self.korrektur
                        self.fax[i]=float(self.ax[i].get()) * self.korrektur

                if self.hel=='p':
                        self.farichtung[i]=float(self.arichtung[i].get())
                        zwischen=self.azenitdistanz[i].get()
                        if not zwischen or zwischen.isspace():
                            self.azenitdistanz[i].insert(0,"100.")
                        self.fazenitdistanz[i]=float(self.azenitdistanz[i].get())
                        self.fastrecke[i]=float(self.astrecke[i].get())

                        frired=(self.farichtung[i] - self.farichtung[0])*math.pi/200.

                        # Reduktion mit Anfangsrichtung

                        fzeb=(self.fazenitdistanz[i])*math.pi/200.
                        fastrred=math.sin(fzeb)* self.fastrecke[i] * self.korrektur
                        self.fay[i]=fastrred * math.sin(frired)
                        self.fax[i]=fastrred * math.cos(frired)

                self.fby[i]=self.faddy + float(self.by[i].get())
                self.fbx[i]=self.faddx + float(self.bx[i].get())
                self.by[i].delete(0,END)
                self.by[i].insert(0, str(round(self.fby[i],3)))
                self.bx[i].delete(0,END)
                self.bx[i].insert(0, str(round(self.fbx[i],3)))

            if self.nnaktiv <2:
                self.taste2()
                tkinter.messagebox.showinfo("          Achtung", "Berechnung nicht möglich, weil \
die Anzahl der aktiven Passpunkte kleiner als 2 ist.")
                return

            # Berechnung der Schwerpunkte

            self.fays = self.faxs = self.fbys = self.fbxs = 0.
            for i in range(self.nalt):
               if self.aktiv[i]==1:
                  self.fays += self.fay[i]/self.nnaktiv
                  self.faxs += self.fax[i]/self.nnaktiv
                  self.fbys += self.fby[i]/self.nnaktiv
                  self.fbxs += self.fbx[i]/self.nnaktiv
     
            # Berechnung der schwerpunktbezogenen, lokalen Koordinaten

            self.faylokal, self.faxlokal, self.fbylokal, self.fbxlokal=[],[],[],[]
            self.fayjlokal, self.faxjlokal=[],[]
            self.fastrlokal, self.fajsstrlokal= [],[]

            for i in range(self.nalt):
                self.faylokal.append(0.); self.faxlokal.append(0.)
                self.fbylokal.append(0.); self.fbxlokal.append(0.), self.fastrlokal.append(0.)
            for i in range(self.nalt):
                    self.faylokal[i]=self.fay[i] - self.fays
                    self.faxlokal[i]=self.fax[i] - self.faxs
                    self.fbylokal[i]=self.fby[i] - self.fbys
                    self.fbxlokal[i]=self.fbx[i] - self.fbxs
            fsu1 = fsu2 = fsu3 = fsu4 = fsu5 = 0.  # Zwischenwerte für o und a

            for i in range(self.nalt):
                if self.aktiv[i]==1:
                    self.fastrlokal[i] = math.hypot(self.faylokal[i],self.faxlokal[i])
                    fsu1=fsu1 + self.fbylokal[i]*self.faxlokal[i]
                    fsu2=fsu2 + self.fbxlokal[i]*self.faylokal[i]
                    fsu3=fsu3 + self.fbylokal[i]*self.faylokal[i]
                    fsu4=fsu4 + self.fbxlokal[i]*self.faxlokal[i]
                    fsu5=fsu5 + self.faylokal[i]*self.faylokal[i] + \
                          self.faxlokal[i]*self.faxlokal[i]

            self.fasstr = math.fsum(self.fastrlokal)/self.nnaktiv  # mittl. Streckenlänge zum Schwerpunkt System A
            self.fasstrmax = max(self.fastrlokal)                  # Maximale Streckenlänge zum Schwerpunkt System A
            fasstr_sortiert= sorted(self.fastrlokal)               # Median-Strecke zum Schwerpunkt System A
            nMedian = len(fasstr_sortiert)
            if nMedian % 2 == 0:
               self.fasstrm = (fasstr_sortiert[nMedian//2-1] + fasstr_sortiert[nMedian//2]) / 2
            else:
               self.fasstrm = fasstr_sortiert[nMedian//2]
#--------------------------------------------------------------

            # Bearbeitung der zu transformierenden Koordinaten

            self.fayj, self.faxj, self.fbyj, self.fbxj, self.fayjlokal, \
                       self.faxjlokal =[],[],[],[],[],[]
            if self.hel=='p':farichtungj, fazenitdistanzj, fastreckej=[],[],[]

            self.o=(fsu1 - fsu2)/fsu5; self.a=(fsu3 + fsu4)/fsu5;      # Transformationsparameter

            self.Y0 = self.fbys - self.o*self.faxs - self.a*self.fays  # Translationsunbekannte
            self.X0 = self.fbxs - self.a*self.faxs + self.o*self.fays

            self.massstab=math.hypot(self.o,self.a)

            self.ms=self.ntransm.get()
            if self.ms=="1":
                self.o=self.o/self.massstab     # o',  sin(alpha)
                self.a=self.a/self.massstab     # a',  cos(alpha)
            self.falphab = math.atan(self.o/self.a)
            self.falpha=self.falphab * 200./math.pi  # Drehwinkel

            if self.hel=='p':                        # Standpunkt
                self.fbystand=self.fbys - self.a*self.fays - self.o*self.faxs
                self.fbxstand=self.fbxs - self.a*self.faxs + self.o*self.fays

            # Erzeugung der float-Variablen Frame40

            for j in range(self.nneu):
                if self.hel=='p':
                    self.farichtungj.append(0.); self.fazenitdistanzj.append(0.)
                    self.fastreckej.append(0.)
                self.fayj.append(0.); self.faxj.append(0.)
                self.fbyj.append(0.); self.fbxj.append(0.)
                self.fayjlokal.append(0.); self.faxjlokal.append(0.)
                self.fajsstrlokal.append(0.)

            if self.hel=='o':
                for j in range(self.nneu):
                    self.fayj[j]=float(self.ayj[j].get())* self.korrektur
                    self.faxj[j]=float(self.axj[j].get())* self.korrektur
            if self.hel=='p':
                for j in range(self.nneu):
                    self.farichtungj[j]=float(self.arichtungj[j].get())
                    zwischen=self.azenitdistanzj[j].get()
                    if not zwischen or zwischen.isspace():
                        self.azenitdistanzj[j].insert(0,"100.")
                    self.fazenitdistanzj[j]=float(self.azenitdistanzj[j].get())
                    self.fastreckej[j]=float(self.astreckej[j].get())
                    # Reduktion mit Anfangsrichtung
                    frired=(self.farichtungj[j] - self.farichtung[0])*math.pi/200.
                    fzeb=(self.fazenitdistanzj[j])*math.pi/200.
                    fastrredj=math.sin(fzeb)* self.fastreckej[j] * self.korrektur
                    self.fayj[j]=fastrredj * math.sin(frired)
                    self.faxj[j]=fastrredj * math.cos(frired)
            for j in range(self.nneu):
                self.fayjlokal[j]=self.fayj[j] -  self.fays    # auf den Schwerpunkt bezogen
                self.faxjlokal[j]=self.faxj[j] -  self.faxs
                self.fajsstrlokal[j]= math.hypot(self.fayjlokal[j],self.faxjlokal[j])
            self.fajsstrmax = max(self.fajsstrlokal) # Maximale Streckenlänge zum Schwerpunkt System B
            for i in range(self.nalt):
                if self.aktiv[i]==1:
                    self.fbyger[i]= self.fbys + self.a* self.faylokal[i] + self.o* self.faxlokal[i]
                    self.fbxger[i]= self.fbxs + self.a* self.faxlokal[i] - self.o* self.faylokal[i]

            for j in range(self.nneu):
                self.fbyj[j]= self.fbys + self.a* self.fayjlokal[j] + self.o* self.faxjlokal[j]
                self.fbxj[j]= self.fbxs + self.a* self.faxjlokal[j] - self.o* self.fayjlokal[j]
                self.byj[j].delete(0,END)
                self.byj[j].insert(0, str(round(self.fbyj[j],3)))
                self.bxj[j].delete(0,END)
                self.bxj[j].insert(0, str(round(self.fbxj[j],3)))

            varianzsumme=0.
            for i in range(self.nalt):       # Restklaffenausgabe in Entry nalt
                if self.aktiv[i]==1:
                    self.fvy[i]=self.fby[i] - self.fbyger[i]
                    self.fvx[i]=self.fbx[i] - self.fbxger[i]
                    self.fklaffe[i]=math.hypot(self.fvy[i], self.fvx[i])
                    self.vy[i].delete(0,END)
                    self.vy[i].insert(0, str(round(self.fvy[i],3)))
                    self.vx[i].delete(0,END)
                    self.vx[i].insert(0, str(round(self.fvx[i],3)))
                    self.klaffe[i]["bg"]="Lightyellow"
                    self.klaffe[i].delete(0,END)
                    self.klaffe[i].insert(0, str(round(self.fklaffe[i],3)))
                    varianzsumme=varianzsumme + (self.fvy[i])**2 + (self.fvx[i])**2

            max_klaffe = max(self.fklaffe)       # Einfärben der maximalen Klaffe
            max_index = self.fklaffe.index(max_klaffe)
            self.klaffe[max_index]["bg"]="Yellow"

            #  Restklaffenverteilung (angepasst)

            stre, p, pj,  self.fuyj, self.fuxj  = [],[],[],[],[]
            for i in range(self.nalt): p.append(0.), stre.append(0.)
            for j in range(self.nneu): pj.append(0.),self.fuyj.append(0.), self.fuxj.append(0.)
            for j in range(self.nneu):

                 if self.ntransr.get() == 0:    # Restklaffenverteilung ohne
                     self.fuyj[j]=0.; self.fuxj[j]=0.;
                     continue

                 for i in range(self.nalt):
                     if self.aktiv[i]==1: 
                         stre[i]=math.hypot(self.fbyj[j]-self.fby[i], self.fbxj[j]-self.fbx[i])       
                         if self.ntransr.get() == 1:       # Restklaffenverteilung linear
                             p[i]=1/stre[i]
                         elif self.ntransr.get() == 2:     # Restklaffenverteilung s-exp(1,5)
                             p[i]= 1/(stre[i]*math.sqrt(stre[i]))    
                         elif self.ntransr.get() == 3:     # Restklaffenverteilung quadratisch  
                             p[i]= 1/(stre[i]**2)

                 summepvy = 0.; summepvx = 0.
                 for i in range(self.nalt):
                    if self.aktiv[i]==1: 
                       summepvy += (self.fvy[i] * p[i])
                       summepvx += (self.fvx[i] * p[i])
                 summep = sum(map(float, p))  
                 self.fuyj[j]= summepvy/summep; self.fuxj[j]= summepvx/summep
                 self.fbyj[j] += self.fuyj[j]
                 self.fbxj[j] += self.fuxj[j]

            for j in range(self.nneu):
                 self.byj[j].delete(0,END)
                 self.byj[j].insert(0, str(round(self.fbyj[j],3)))
                 self.bxj[j].delete(0,END)
                 self.bxj[j].insert(0, str(round(self.fbxj[j],3)))
                 self.uyj[j].delete(0,END)
                 self.uyj[j].insert(0, str(round(self.fuyj[j],3)))
                 self.uxj[j].delete(0,END)
                 self.uxj[j].insert(0, str(round(self.fuxj[j],3)))
            if self.nnaktiv < 3:
                self.mgewichtseinheit = math.sqrt(varianzsumme)
            else:
                if self.ms == "1":
                   self.mgewichtseinheit = math.sqrt(varianzsumme/(2*self.nnaktiv - 3))
                else:
                   self.mgewichtseinheit = math.sqrt(varianzsumme/(2*self.nnaktiv - 4))
            self.fklaffemittel = math.sqrt(2.)* self.mgewichtseinheit

            self.druck=1
            command=self.ergebnisausgabe()
        except:
            self.druck=0
            tkinter.messagebox.showerror("Fehler", "Fehlerhafte Eingabe\nFalsche \
Zeichen, unerlaubt leeres Feld … ?")
            self.textueber["text"]=""
            return

    def punktdeaktiv(self):          # in def ergebnisausgabe(self)
                                     # Behandlung deaktiver Punkte
        for i in range(self.nalt):
                if self.aktiv[i]==0:
                    # auf den Schwerpunkt bezogen  
                    self.faylokal[i]=self.fay[i] - self.fays
                    self.faxlokal[i]=self.fax[i] - self.faxs
                    self.fbylokal[i]=self.fby[i] - self.fbys
                    self.fbxlokal[i]=self.fbx[i] - self.fbxs

        for i in range(self.nalt):
                if self.aktiv[i]==0:
                    self.fbyger[i]= self.fbys + self.a* self.faylokal[i] + self.o* self.faxlokal[i]
                    self.fbxger[i]= self.fbxs + self.a* self.faxlokal[i] - self.o* self.faylokal[i]

        for i in range(self.nalt):
                if self.aktiv[i]==0:
                    self.fvy[i]=self.fby[i] - self.fbyger[i]
                    self.fvx[i]=self.fbx[i] - self.fbxger[i]
                    self.fklaffe[i]=math.hypot(self.fvy[i], self.fvx[i])
                    self.vy[i].delete(0,END)
                    self.vy[i].insert(0, str(round(self.fvy[i],3)))
                    self.vx[i].delete(0,END)
                    self.vx[i].insert(0, str(round(self.fvx[i],3)))
                    self.klaffe[i].delete(0,END)
                    self.klaffe[i].insert(0, str(round(self.fklaffe[i],3)))
                    self.klaffe[i]["bg"]="Pink"                 
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def bposition(self, t):     # Warnzeichen, erneut setzen
       self.taste2()
       if self.aktiv[t]==1:
           self.pkza[t]["bg"]="Pink"
           self.aktivtext[t].configure(state='normal')
           self.aktivtext[t].delete(0, END)
           self.aktivtext[t].insert(0, " Nein")
           self.aktivtext[t].configure(state='disabled')
           self.aktivtext[t].configure(disabledforeground="red")
           self.aktiv[t]=0
           self.vx[t].delete(0,END)
           self.vy[t].delete(0,END)
           self.klaffe[t].delete(0,END)
       else:
           self.pkza[t]["bg"]="white"
           self.aktiv[t]=1
           self.aktivtext[t].configure(state='normal')
           self.aktivtext[t].delete(0, END)
           self.aktivtext[t].insert(0, "   Ja")
           self.aktivtext[t].configure(state='disabled')
           self.aktivtext[t].configure(disabledforeground="green")
           self.klaffe[t]["bg"]="Lightyellow"
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def infodel(self):
        self.newWindow.destroy()

    def punktegrafik(self):
        if self.druck==0 or self.marke==0:
            tkinter.messagebox.showinfo("Achtung", "Erst <Rechnen> drücken!")
            return
        text=  "Projekt: " + self.tprojekt +"\n"
        if self.ms=="1":
            text += self.tex12
        else:
            text += self.tex13
        self.newWindow = Toplevel()
        self.newWindow.title("Helmerttransformation, Punkteübersicht, Vektorenplan")

        if self.eingabe.get()==1:
            self.tausgabe = "Ausgabe: C:/tmp/_Datenausgabe.txt" 
        if self.eingabe.get()==2:
            self.tausgabe = "Ausgabe: " + str(self.file_path_red) +"_Datenausgabe.txt"
         
        Label(self.newWindow, text =(text + "\n" + str(self.nnaktiv)+ " aktive Passpunkte (blaue Dreiecke) und " +\
                str(self.nneu) +  " transformierte(r) Punkt(e)(rote Kreise)\n" + self.tausgabe + "\nBerechnungsdatum: " +\
                time.strftime("%d.%m.%Y  %H:%M:%S\n")) ).pack()
        self.newWindow.attributes("-topmost", 1)

        fmaxby = max(self.fby)
        fminby = min(self.fby)
        fmaxbx = max(self.fbx)
        fminbx = min(self.fbx)
      
        fmaxbyj = max(self.fbyj)
        fminbyj = min(self.fbyj)
        fmaxbxj = max(self.fbxj)
        fminbxj = min(self.fbxj)

        fminminby = min(fminby,fminbyj)
        fminminbx = min(fminbx,fminbxj)
        fybreite = max(fmaxby,fmaxbyj) - fminminby
        fxhoehe = max(fmaxbx,fmaxbxj) -fminminbx

        pymargin=100; pxmargin=100

        pklaffeeinheit =120
        if fybreite/fxhoehe > 1.4:
           pxbreite = 1000
           pyhoehe = pxbreite*fxhoehe/fybreite
        else:
           pyhoehe = 600
           pxbreite =  pyhoehe*fybreite/fxhoehe
        pcanvasy = pyhoehe + 2*pymargin  # = ph (Abkürzung)
        pcanvasx = pxbreite + 2*pxmargin

        if max(self.fklaffe) > 2:
           fverhklaffe = pklaffeeinheit/5
           tklaffe = " 5m"
        elif max(self.fklaffe) < 0.05:
           fverhklaffe = pklaffeeinheit/0.01
           tklaffe = " 1cm"
        elif max(self.fklaffe) < 0.15:
           fverhklaffe = pklaffeeinheit/0.05
           tklaffe = " 5cm"
        else:
           fverhklaffe = pklaffeeinheit/0.5
           tklaffe = " 0,5m"
        fverhmassstab = pxbreite/fybreite
        pmass=int(fverhmassstab*100)
        pcanvas = Canvas(self.newWindow, width=pcanvasx, height=pcanvasy)
        for i in range(self.nalt):
            px = int(pxmargin + (self.fby[i]-fminminby)*fverhmassstab)
            py = int(pyhoehe + pymargin - (self.fbx[i]-fminminbx)*pyhoehe/fxhoehe)
            text= self.pkza[i].get().lstrip()
            pcanvas.create_text(px+10+3*len(text), py, text= text)
            if self.aktiv[i] == 1:
                pcanvas.create_polygon(px-8, py+8, px+8, py+8, px, py-4,px-8, py+8, fill="blue")
                pcanvas.create_line(px, py+4,px + \
                            int(fverhklaffe*self.fvy[i]), py + int(-fverhklaffe*self.fvx[i]),fill="blue", width = 2,arrow = LAST)
            if self.aktiv[i] == 0:
                pcanvas.create_line(px-8, py+8, px+8, py+8, px, py-4, px-8, py+8)
                pcanvas.create_text(px+10+3*len(text), py, text= text)
        if self.hel =='p':
            px = int(pxmargin + (self.fbystand-fminminby)*fverhmassstab)
            py = int(pyhoehe + pymargin - (self.fbxstand-fminminbx)*pyhoehe/fxhoehe)
            pcanvas.create_text(px+40, py, text= "Standpunkt")
            pcanvas.create_oval(px-3, py+3, px+3, py-3, fill="green")
        for j in range(self.nneu):
             px = int(pxmargin+ (self.fbyj[j]-fminminby)*fverhmassstab)
             py = int(pyhoehe + pymargin - (self.fbxj[j]-fminminbx)*pyhoehe/fxhoehe)
             pcanvas.create_oval(px-3, py+3, px+3, py-3, fill="red")

        ph= pcanvasy

        pcanvas.create_line(20, ph-35,20,ph-45,20,ph-40,20+pmass,ph-40,20+pmass,ph-35,20+pmass,ph-45,  width = 2)
        pcanvas.create_text(80, ph-53, text= "Maßstab \u27F9 100m",justify = LEFT)

        pcanvas.create_line(20,ph-10,pklaffeeinheit+20,ph-10, fill="blue",  arrow = LAST, width = 2)
        pcanvas.create_text(80, ph-23, text= "Restklaffe \u27F9 " + tklaffe, justify = LEFT)
        pcanvas.pack()

        self.frame50=Frame(self.newWindow, relief=RIDGE,bd=0)
        self.frame50.pack()      

        self.bende = Button(self.frame50, text = "\u274C   Grafik  schließen", fg='white', bg='red', bd=2, font=('Arial',11), relief=GROOVE,
                command = self.infodel)
        self.bende.pack(side=LEFT)
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def redundanzen(self):    # Redundanzen
        redundanzzaehler = 0.
        summelokalquadrate= 0.
        self.hii = []; self.rii = []
        self.riiproy = []; self.riiprox= []
        for i in range(self.nalt):
            if self.aktiv[i]==1:
                redundanzzaehler += 1
                summelokalquadrate += (self.fastrlokal[i])**2
            self.hii.append(0.); self.rii.append(1.0)
            self.riiproy.append(0.); self.riiprox.append(0.)
        if self.ms =="0":                               # 4-Parameter
            for i in range(self.nalt):
                if self.aktiv[i]==1:
                    self.hii[i] = 1/(redundanzzaehler) + ((self.faylokal[i])**2 + (self.faxlokal[i])**2)/summelokalquadrate
                    self.rii[i] -=  self.hii[i]
                    self.riiproy[i] = 100. * self.rii[i]
                    self.riiprox[i] = self.riiproy[i]
        if self.ms =="1":                              # 3-Parameter
            for i in range(self.nalt):
                if self.aktiv[i]==1:
                    self.hii[i] = 1/(redundanzzaehler) + (((self.faxlokal[i])*math.cos(self.falpha*math.pi/200.)\
                        - (self.faylokal[i])*math.sin(self.falpha*math.pi/200.))**2)/summelokalquadrate
                    self.rii[i] = 1 -  self.hii[i]
                    self.riiproy[i] = 100. * self.rii[i]       
                    self.hii[i] = 1/(redundanzzaehler) + (((self.faxlokal[i])*math.sin(self.falpha*math.pi/200.)+\
                        (self.faylokal[i])*math.cos(self.falpha*math.pi/200.))**2)/summelokalquadrate
                    self.rii[i] = 1 - self.hii[i]

                    self.riiprox[i] = 100. * self.rii[i]
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     
    def textbausteine(self):    # Textbausteine
        self.margin = "\n"+' '*0       # linker Rand der Printausgabe
        self.tex010 = "Code 10: Orthogonale Passpunkte bzw. Stützpunkte"
        self.tex011 = "Code 11: Orthogonale Passpunkte mit Restklaffen, nach der Transformation"
        self.tex020 = "Code 20: Orthogonale zu transformierende Punkte"
        self.tex021 = "Code 21: Orthogonale zu transformierende Punkte, nach der Transformation"
        self.tex030 = "Code 30: Polare bzw. orthogonale Passpunkte"
        self.tex031 = "Code 31: Polare bzw. orthogonale Passpunkte, nach der Transformation"
        self.tex040 = "Code 40: Polare zu transformierende Punkte"
        self.tex041 = "Code 41: Polare zu transformierende Punkte, nach der Transformation"

        self.tex01 = self.margin + '_'*84 + "\n"
        self.tex02 = self.margin + '-'*84 + "\n"
        self.tex10 = self.margin + ' '*25  +"*** Helmerttransformation ***"  + ' '*22 +  "Seite "
        self.tex11 = "***** Ergebnisse der Transformation *****"
        self.tex12 = "3-Parameter-Transformation"
        self.tex13 = "4-Parameter-Transformation"
        self.tex14 = "Anzahl der aktiven Passpunkte = " + str(self.nnaktiv)
        self.tex15 = "rechtsläufiger Drehwinkel der Achsen: System B nach A = " +str(round(self.falpha,7)) + " gon"
        if self.hel=='p':
            self.tex16 = "Standpunktkoordinaten im System B: Y = " + str(round(self.fbystand,3)) +\
                          ", X = " + str(round(self.fbxstand,3))

        self.tex18 = "Reduktion und Verzerrung wurden nicht berücksichtigt"          
        self.tex19 = "      Koordinaten berechnet mit m = 1 (ermittelt m = "+ str(round(self.massstab, 8)) +")"
        self.tex20 = "      Koordinaten berechnet mit m = " + str(round(self.massstab, 8))
        self.tex21 = "keine Anpassung der Restklaffen an den zu transformierenden Punkten"
        self.tex22 = "Restklaffenverteilung an den zu transformierenden Punkten"
        self.tex23 = "      mit Abstandsgewichten 1/s"
        self.tex24 = "      mit Abstandsgewichten 1/(s*sqrt(s))"
        self.tex25 = "      mit Abstandsgewichten 1/s\u00B2"
        self.tex26 = "Standardabweichung der Gewichtseinheit = " + str(round(self.mgewichtseinheit, 3))
        self.tex27 = " zum Schwerpunkt des lokalen Systems A = "
        self.tex28 = "Auf die Stützpunkte bezogen:" +\
                     "\n      mittlere Streckenlänge" +  self.tex27 + str(round(self.fasstr, 3)) +\
                     "\n      maximale Streckenlänge" +  self.tex27 + str(round(self.fasstrmax, 3)) +\
                     "\n      Median der Streckenlängen" +  self.tex27 + str(round(self.fasstrm, 3))+\
                     "\nAuf die zu transformierenden Punkte bezogen:" +\
                     "\n      maximale Streckenlänge" +  self.tex27+ str(round(self.fajsstrmax, 3)) +\
                     "\n      Der nach <ex> angezeigte Wert ist das Verhältnis von Strecke/Median System A " +\
                     "\n            wenn es größer als 1,5 ist."
        self.tex29 = "      mittlere restliche Klaffung = " + str(round(self.fklaffemittel, 3))
        if self.verz.get()=="1":
            self.tex40 = "Lagesystem: ETRS89 (489); Bezugsellipsoid: GRS80; Abbildung: UTM"
            self.tex41 = "      Reduktion und Verzerrung (r = " + str(round(self.fkorrektur, 8)) +") wurden berücksichtigt"
            self.tex42 = "      Undulation = {0:>4.1f} m, mittl. Höhe ü.NHN ={1:>6.1f} m, \
".format(self.fundulation, self.fhoeheNHN,)
            self.tex43 = "mittl. UTM-Ostwert[km] ={0:>4.0f}".format(self.fostwert)
            self.tex44 = "      Reduktionsfakor = {0:>10.7f}\n".format(self.korrektur)
        self.tex45 = "Schwerpunkt der Passpunkte, System A, ys ={0:>11.3f}, xs ={1:>11.3f}".format(self.fays, self.faxs)
        self.tex46 = "Schwerpunkt der Passpunkte, System B, Ys ={0:>11.3f}, Xs ={1:>11.3f}".format(self.fbys, self.fbxs)
        self.tex47 = "Translationsunbekannte Y0 ={0:11.3f}, X0 ={1:11.3f}".format(self.Y0, self.X0)
    #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def ergebnisausgabe(self):   # in Datei und Display
        self.textbausteine()
        self.punktdeaktiv()
        self.displayausgabe()
        self.datenausgabe()

    def printausgabe(self):
        if self.druck==0 or self.marke==0:
            tkinter.messagebox.showinfo("Achtung", "Erst <Rechnen> drücken!")
            return
        self.redundanzen()
        self.textbausteine()
        self.zeilenzähler = 0
        self.text = self.margin + self.tex10 + "1 "
        self.text += self.margin + "Projekt: " + self.tprojekt
        self.text += self.margin + "Berechnungsdatum: "+ time.strftime("%d.%m.%Y\n") + self.tex01 
        if self.hel == "p":
            self.text +=self.margin + "Polaraufnahme"
        if self.verz.get()=="1":
            self.text += self.margin + self.tex40
            self.text += self.margin + self.tex42 + self.tex43
            self.text += self.margin + self.tex41
        if self.ms=="1":
            self.text +=self.margin + self.tex12 + self.margin + self.tex19
        else:
            self.text +=self.margin + self.tex13 + self.margin + self.tex20
        if self.ntransr.get()==0:
            self.text +="\n" + self.tex21
        else:
            self.text +="\n" +self.tex22 +  "\n"
        if self.ntransr.get()==1:
            self.text +=self.tex23
        elif self.ntransr.get()==2:
            self.text +=self.tex24
        elif self.ntransr.get()==3:
            self.text +=self.tex25
        self.text += self.margin + self.tex26 + self.margin + self.tex29
        self.text += "\n" +self.margin + self.tex28 + "\n"
        self.text += self.margin + self.tex15
        if self.hel=='p':
            self.text += self.margin + self.tex16
        self.text += self.margin + self.tex45 + self.margin + self.tex46 + self.margin +self.tex47
        self.text += self.tex01
        self.text += "\n" + self.margin + ' '*6 + "Transformation der Elemente bzw. Koordinaten der gegebenen Passpunkte"
        self.text += "\n" + self.margin + "                  vom System A            zum System B (Ziel)"
        if self.hel =='o':
            self.text += "\n" + self.margin + "Punktkennzeichen  yi          xi           \
Yi          Xi      vyi     vxi    Klaffe"
            self.text += self.tex02
            for i in range(self.nalt):
                if self.aktiv[i] == 1:
                    self.text += self.margin + self.pkza[i].get() + " {0:>11.3f} {1:>11.3f}  {2:>11.3f} \
{3:>11.3f} {4:>7.3f} {5:>7.3f} {6:>7.3f} ".format(self.fay[i],self.fax[i],self.fby[i],self.fbx[i], \
                                                  self.fvy[i], self.fvx[i],self.fklaffe[i])  
                    self.text += self.margin + ' '*60 + "ry= {0:>2.0f}% rx= {1:>2.0f}% \
".format(self.riiproy[i],self.riiprox[i])
        else:
            self.text += self.margin +"      PKZ   Richt. Zenitd.  Strecke       Yi          \
Xi      vyi     vxi    Klaffe"
            self.text += self.tex02
            for i in range(self.nalt):
              if self.aktiv[i] == 1:
                self.text +=self.margin + self.pkza[i].get() +"{0:>7.3f} {1:>7.3f} {2:>8.3f} \
{3:>11.3f} {4:>11.3f} {5:>7.3f} {6:>7.3f} {7:>7.3f} ".format(self.farichtung[i],self.fazenitdistanz[i],\
                self.fastrecke[i], self.fby[i],self.fbx[i], self.fvy[i], self.fvx[i],self.fklaffe[i])
                self.text += self.margin + ' '*60 + "ry= {0:>2.0f}% rx= {1:>2.0f}% \
".format(self.riiproy[i],self.riiprox[i])
        self.text += self.tex01
        self.text += "\n" + self.margin + ' '*16 +"zu transformierende Punkte des Systems A"
        self.text += "\n" + self.margin + "                   vom System A           zum System \
B (Ziel, berechnet)"

        if self.hel=='o':
            self.text += "\n" + self.margin +                "Punktkennzeichen  yj          xj\
           Yj          Xj     uyj, uxj (angepasst)"
            self.text += self.tex02
            for j in range(self.nneu):
                fex = self.fajsstrlokal[j]/self.fasstrm  #Verhältnis lokale Strecke/Median
                self.text +=self.margin + self.pkzj[j].get() + " {0:>11.3f} {1:>11.3f}  {2:>11.3f} \
{3:>11.3f} {4:>7.3f} {5:>7.3f}".format(self.fayj[j],self.faxj[j],self.fbyj[j],self.fbxj[j], \
                                       self.fuyj[j], self.fuxj[j])
                if fex > 1.5: self.text +=  " ex {0:>3.1f}".format(fex)  
        else:         
            self.text += self.margin + "      PKZ   Richt. Zenitd.  Strecke          Yj          \
Xj    uyj, uxj(angepasst)"
            self.text += self.tex02
            for j in range(self.nneu):
                fex = self.fajsstrlokal[j]/self.fasstrm  #Verhältnis lokale Strecke/Median
                self.text +=self.margin + self.pkzj[j].get() + " {0:>7.4f} {1:>7.4f} {2:>8.3f} \
{3:>11.3f} {4:>11.3f} {5:>7.3f} {6:>7.3f}\
".format(self.farichtungj[j], self.fazenitdistanzj[j], self.fastreckej[j], self.fbyj[j],\
         self.fbxj[j], self.fuyj[j], self.fuxj[j])
                if fex > 1.5: self.text +=  " ex {0:>3.1f}".format(fex)

        if self.eingabe.get()==1:    # manuelle Eingabe
            tkinter.messagebox.showinfo("Hinweis", "Die Daten finden sich in der Datei --> C:/tmp/_Printausgabe.txt\nEmpfohlene Schriftart: Courier New, Schriftgröße: 9")
            with open("C:/tmp/_Printausgabe_tmp.txt", "w") as file4:
                file4.write("")
            file4=open("C:/tmp/_Printausgabe_tmp.txt", "a")

        if self.eingabe.get()==2:    # Dateieingabe
            tkinter.messagebox.showinfo("Hinweis", "Die Daten finden sich in der Datei C:/tmp/_Printausgabe.txt\nEmpfohlene Schriftart: \
Courier New, Schriftgröße: 9")
            with open(self.file_path_red +"_Printausgabe_tmp.txt", "w") as file4:
                file4.write("")
            file4=open(self.file_path_red +"_Printausgabe_tmp.txt", "a")
     
        file4.write(self.text)
        file4.close()
        self.seite = 1
        self.zeile = 0
        if self.eingabe.get()==1:
            file4=open("C:/tmp/_Printausgabe_tmp.txt", "r")
            file5=open("C:/tmp/_Printausgabe.txt", "w")
            # Öffnen der Textdatei und Erzeugen von Textzeilen
            with open("C:/tmp/_Printausgabe_tmp.txt", 'r') as file: content=file.read()
        if self.eingabe.get()==2:
            file4=open(self.file_path_red +"_Printausgabe_tmp.txt", "r")
            file5=open(self.file_path_red +"_Printausgabe.txt", "w")
            # Öffnen der Textdatei und Erzeugen von Textzeilen
            with open(self.file_path_red +"_Printausgabe_tmp.txt", 'r') as file: content=file.read()

        # Trennen des Inhalts in einzelne Zeilen
        lines=content.splitlines()
        for line in lines:
            if self.zeile > 70:
                self.seite += 1
                self.zeile = 8     
                file5.write("\f\n" + self.tex10 + str(self.seite) + self.tex01)
                file5.write(self.margin + "Projekt: " + self.tprojekt)
                file5.write(self.margin + "Berechnungsdatum: "+ time.strftime("%d.%m.%Y\n") + self.tex01 + "\n")
            file5.write(line + "\n")
            self.zeile += 1

        file4.close()
        if self.eingabe.get()==1:
            os.remove("C:/tmp/_Printausgabe_tmp.txt")
        if self.eingabe.get()==2:
            os.remove(self.file_path_red +"_Printausgabe_tmp.txt")
        file5.close()

        if self.ms=="1":
            self.text +=self.margin + self.tex12 + self.margin + self.tex19
        else:
            self.text +=self.margin + self.tex13 + self.margin + self.tex20
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def displayausgabe(self):
        if self.ms=="1":
            ausgabe1= self.tex12 + "\n" + self.tex19
        else:
            ausgabe1= self.tex13 + "\n" + self.tex20
        ausgabe1 += "\nAnzahl der aktiven Passpunkte = " + str(self.nnaktiv)

        if self.hel=='p':
            ausgabe2 = self.tex16
        else:
            ausgabe2 = self.tex15
            
        ausgabe1 +=  "\n" + ausgabe2

        if self.verz.get()=="1":
            ausgabe3 = self.tex41
        else:
            ausgabe3 = self.tex18
        ausgabe1 += "\n" + ausgabe3

        if self.ntransr.get()==0:
            ausgabe5 = self.tex21
            ausgabe1 += "\n" + ausgabe5
        else:
            ausgabe5=self.tex22
            if self.ntransr.get()==1:
                ausgabe6 = self.tex23
            elif self.ntransr.get()==2:
                ausgabe6 = self.tex24
            elif self.ntransr.get()==3:
                ausgabe6 = self.tex25
            ausgabe1 += "\n" + ausgabe5 + "\n       " + ausgabe6
        if self.nnaktiv >2:
            ausgabe11 = self.tex29
            ausgabe1 += "\n" + ausgabe11
        self.text34["text"]=ausgabe1
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    def datenausgabe(self):         # in Datei
        if self.eingabe.get()== 1:
            file4=open("C://tmp//_Datenausgabe.txt", "w")
        if self.eingabe.get()== 2:
            file4=open(self.file_path_red +"_Datenausgabe.txt", "w")
        file4.write("C ***** Eingabedaten (manuell oder ursprünglich aus einer Datei) *****")
        file4.write("\n01;Projekt: " + self.tprojekt)
        file4.write("\n02;Berechnungsdatum: " +\
                    time.strftime("%d.%m.%Y   %H:%M:%S"))
        if self.verz.get()=="1":
            file4.write("\n99 " + self.tex40)
            file4.write("\n99 "  + self.tex42 + self.tex43)
            file4.write("\n99 "  + self.tex41)
        if self.hel=='o':
            file4.write("\nC " + self.tex010)
            file4.write("\nC Code;   PKZ;        Ayi;        Axi;        BYi;        BXi;")
            for i in range(self.nalt):
                if self.aktiv[i] == 1:
                    file4.write("\n10;")
                else:
                    file4.write("\n99;")
                file4.write("{0:>10};{1:>11};{2:>11};{3:>11};{4:>11};\
".format(self.pkza[i].get(), self.ay[i].get(), self.ax[i].get(), self.by[i].get(), self.bx[i].get()))              
            file4.write("\n99\nC " + self.tex020)
            file4.write("\nC Code;   PKZ;        Ayj;        Axj;")
            for j in range(self.nneu):
                file4.write("\n20;{0:>10};{1:>11};{2:>11};\
".format(self.pkzj[j].get(),self.ayj[j].get(),self.axj[j].get()))

        if self.hel=='p':
            file4.write("\nC " + self.tex030)
            file4.write("\nC Code;   PKZ; ARichtung i; AZenitdistanz i; AStrecke i;  BYi;   BXi;")
            for i in range(self.nalt):
                if self.aktiv[i] == 1:
                    file4.write("\n30;")
                else:
                    file4.write("\n99;")
                file4.write("{0:>10};{1:>8};{2:>8};{3:>8};{4:>11};{5:>11};\
".format(self.pkza[i].get(), self.arichtung[i].get(), self.azenitdistanz[i].get(),\
                     self.astrecke[i].get(), self.by[i].get(), self.bx[i].get()))

            file4.write("\n99\nC " + self.tex040)
            file4.write("\nC Code;   PKZ; ARichtung j; AZenitdistanz j; AStrecke j;")
            for j in range(self.nneu):
                file4.write("\n40;{0:>10};{1:>8};{2:>8};{3:>8};\
".format(self.pkzj[j].get(), self.arichtungj[j].get(),self.azenitdistanzj[j].get(),self.astreckej[j].get()))
#--------------------------------------------------------------
        file4.write("\n99\n99 " + self.tex11 + "\n99 ")

        if self.ms=="1":
            file4.write("\n99 " + self.tex12 +"\n99 " + self.tex19)
        else:
            file4.write("\n99 " + self.tex13 +"\n99 " + self.tex20)
        file4.write("\n99 " + self.tex14)
        file4.write("\n99 " + self.tex15)
        if self.hel=='p':
            file4.write("\n99 " + self.tex16)
        if self.verz.get()=="1":                        # Reduktion, Verzerrung
            file4.write("\n99 " + self.tex41)
        else:
            file4.write("\n99 " + self.tex18)
        if self.ntransr.get()==0:  file4.write("\n99 " + self.tex21) #Restklaffenverteilung
        if self.ntransr.get()==1:  file4.write("\n99 " + self.tex22 + "\n99 " + self.tex23)
        if self.ntransr.get()==2:  file4.write("\n99 " + self.tex22 + "\n99 " + self.tex24)
        if self.ntransr.get()==3:  file4.write("\n99 " + self.tex22 + "\n99 " + self.tex25)
        file4.write("\n99 " + self.tex26 +"\n99 " + self.tex29)
#--------------------------------------------------------------
        file4.write("\n99 ")
        if self.hel=='o':
            file4.write("\nC " + self.tex011)
            file4.write("\nC Code;   PKZ;        Ayi;        Axi;        BYi;        BXi;     vyi;     vxi; Klaffe;")
            for i in range(self.nalt):
                 if self.aktiv[i] == 1:
                     file4.write("\n11:{0:>10};{1:>11};{2:>11};{3:>11};{4:>11};{5:<7.3f}; {6:<7.3f}; {7:>7.3f};\
".format(self.pkza[i].get(), self.ay[i].get(), self.ax[i].get(), self.by[i].get(), self.bx[i].get(), self.fvy[i], self.fvx[i], self.fklaffe[i]))               
            file4.write("\n99 ")
            file4.write("\nC " + self.tex021)
            file4.write("\nC Code;   PKZ;        Ayj;        Axj;        BYj;        BXj;    uyj; uxj(angepasst);")
            for j in range(self.nneu):
                file4.write("\n21;{0:>10};{1:>11};{2:>11};{3:>11};{4:>11};{5:>7.3f}; {6:>7.3f};\
".format(self.pkzj[j].get(),self.ayj[j].get(),self.axj[j].get(),self.byj[j].get(),self.bxj[j].get(), self.fuyj[j], self.fuxj[j]))

        if self.hel=='p':
            file4.write("\nC " + self.tex031)
            file4.write("\nC Code;   PKZ; Aylokal i; Axlokal i;         BYi;         BXi;      vyi;     vxi;  Klaffe;")
            for i in range(self.nalt):
                if self.aktiv[i] == 1:
                    file4.write("\n31;{0:>10}; {1:>8.3f}; {2:>8.3f}; {3:>11}; {4:>11}; {5:>7.3f}; {6:>7.3f}; {7:>7.3f};\
".format(self.pkza[i].get(), self.faylokal[i], self.faxlokal[i], self.by[i].get(), \
                                         self.bx[i].get(), self.fvy[i], self.fvx[i],self.fklaffe[i]))
            file4.write("\n99 ")
            file4.write("\nC " + self.tex041)
            file4.write("\nC Code;   PKZ; Aylokal j; Axlokal j;         BYj;         BXj;      uyj; uxj(angepasst);")
            for j in range(self.nneu): 
                file4.write("\n41;{0:>10}; {1:>8.3f}; {2:>8.3f}; {3:>11.3f}; {4:>11.3f}; {5:>7.3f}; {6:>7.3f};\
".format(self.pkzj[j].get(),self.fayjlokal[j],self. faxjlokal[j], self.fbyj[j],\
                                         self.fbxj[j], self.fuyj[j], self.fuxj[j]))
        file4.write("\n99 ")

        if self.eingabe.get()==2:    # Dateieingabe
            tkinter.messagebox.showinfo("Hinweis", "Die Daten finden sich in der Datei " \
                    + str(self.file_path_red) + "_Datenausgabe.txt")

        if self.eingabe.get()==1:    # manuelle Eingabe
            tkinter.messagebox.showinfo("Hinweis", "Die Daten finden sich in der Datei --> C:/tmp/_Datenausgabe.txt")
# Ende  class Helmert():
#****************************************************************************

f=Helmerttransformation()
